<?php
/**
 * @file Do Ajax handler
 */

// load include
module_load_include('inc', 'do', 'includes/do.hooks');

/**
 * Ajax request handler
 */
function _do_ajax() {
  $response = array('ok' => FALSE);
  // horray we have our own hooks
  $hooks = module_invoke_all('do');

  if (isset($_POST['op'])) {
    $ops = explode(' ', $_POST['op']);
    $op = array_shift($ops);

    // check custom aliases first
    if ($alias = _do_get_alias($op)) {
      $op = $alias;
    }

    // command resolution
    if (in_array($op, $hooks)) {
      $hook_return = call_user_func_array($op, $ops);
      $response = array_merge($response, (array) $hook_return);
    } else if (do_drupal_path_exists($op)) {
      $response['ok'] = TRUE;
      $response['path'] = $op;
    } else {
      $response['msg'] = t('Unrecognised command!');
    }
  }

  drupal_json($response);
  die;
}

/**
 * Autocomplete handler
 * @param string $str
 */
function _do_autocomplete($str) {
  $query = "SELECT action FROM do_alias WHERE name LIKE '%%%s%%' ORDER BY name ASC";
  $resource = db_query($query, $op);
  $results = array();

  while ($row = db_fetch_array($result)) {
    $results[] = $row;
  }

  $response = array(
    'ok' => TRUE,
    'data' => $results
  );

  drupal_json($response);
  die;
}

/**
 * Get command by alias
 * @param string $op
 * @return string|FALSE
 */
function _do_get_alias($op) {
  $query = "SELECT action FROM {do_alias} WHERE name = '%s'";
  return db_result(db_query($query, $op));
}

/**
 * Set an alias for a command
 * @param string $op
 * @param string $alias
 * @return bool
 */
function _do_set_alias($op, $alias) {
  $query = "REPLACE INTO {do_alias} SET action = '%s', name = '%s'";
  return db_query($query, $op, $alias) !== false;
}

/**
 * Determines if path is valid
 * @param string
 * @return int
 */
function do_drupal_path_exists($op) {
  // @todo try to check drupal aliases / sources using drupal_lookup_path()
  $query = "SELECT path FROM {menu_router} WHERE path = '%s'";
  $resource = db_query($query, $op);
  $result = db_result($resource);
  return $result;
}